# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.ReplicaPool.V1beta1.Model.DiskAttachment do
  @moduledoc """
  Specifies how to attach a disk to a Replica.

  ## Attributes

  *   `deviceName` (*type:* `String.t`, *default:* `nil`) - The device name of this disk.
  *   `index` (*type:* `integer()`, *default:* `nil`) - A zero-based index to assign to this disk, where 0 is reserved for the boot disk. If not specified, this is assigned by the server.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :deviceName => String.t(),
          :index => integer()
        }

  field(:deviceName)
  field(:index)
end

defimpl Poison.Decoder, for: GoogleApi.ReplicaPool.V1beta1.Model.DiskAttachment do
  def decode(value, options) do
    GoogleApi.ReplicaPool.V1beta1.Model.DiskAttachment.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.ReplicaPool.V1beta1.Model.DiskAttachment do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
