# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.ReplicaPool.V1beta1.Model.ExistingDisk do
  @moduledoc """
  A pre-existing persistent disk that will be attached to every Replica in the Pool in READ_ONLY mode.

  ## Attributes

  *   `attachment` (*type:* `GoogleApi.ReplicaPool.V1beta1.Model.DiskAttachment.t`, *default:* `nil`) - How the disk will be attached to the Replica.
  *   `source` (*type:* `String.t`, *default:* `nil`) - The name of the Persistent Disk resource. The Persistent Disk resource must be in the same zone as the Pool.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :attachment => GoogleApi.ReplicaPool.V1beta1.Model.DiskAttachment.t(),
          :source => String.t()
        }

  field(:attachment, as: GoogleApi.ReplicaPool.V1beta1.Model.DiskAttachment)
  field(:source)
end

defimpl Poison.Decoder, for: GoogleApi.ReplicaPool.V1beta1.Model.ExistingDisk do
  def decode(value, options) do
    GoogleApi.ReplicaPool.V1beta1.Model.ExistingDisk.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.ReplicaPool.V1beta1.Model.ExistingDisk do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
