# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.ReplicaPool.V1beta1.Model.Replica do
  @moduledoc """
  An individual Replica within a Pool. Replicas are automatically created by the replica pool, using the template provided by the user. You cannot directly create replicas.

  ## Attributes

  *   `name` (*type:* `String.t`, *default:* `nil`) - [Output Only] The name of the Replica object.
  *   `selfLink` (*type:* `String.t`, *default:* `nil`) - [Output Only] The self-link of the Replica.
  *   `status` (*type:* `GoogleApi.ReplicaPool.V1beta1.Model.ReplicaStatus.t`, *default:* `nil`) - [Output Only] Last known status of the Replica.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :name => String.t(),
          :selfLink => String.t(),
          :status => GoogleApi.ReplicaPool.V1beta1.Model.ReplicaStatus.t()
        }

  field(:name)
  field(:selfLink)
  field(:status, as: GoogleApi.ReplicaPool.V1beta1.Model.ReplicaStatus)
end

defimpl Poison.Decoder, for: GoogleApi.ReplicaPool.V1beta1.Model.Replica do
  def decode(value, options) do
    GoogleApi.ReplicaPool.V1beta1.Model.Replica.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.ReplicaPool.V1beta1.Model.Replica do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
