# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.ReplicaPool.V1beta1.Model.ReplicaStatus do
  @moduledoc """
  The current status of a Replica.

  ## Attributes

  *   `details` (*type:* `String.t`, *default:* `nil`) - [Output Only] Human-readable details about the current state of the replica
  *   `state` (*type:* `String.t`, *default:* `nil`) - [Output Only] The state of the Replica.
  *   `templateVersion` (*type:* `String.t`, *default:* `nil`) - [Output Only] The template used to build the replica.
  *   `vmLink` (*type:* `String.t`, *default:* `nil`) - [Output Only] Link to the virtual machine that this Replica represents.
  *   `vmStartTime` (*type:* `String.t`, *default:* `nil`) - [Output Only] The time that this Replica got to the RUNNING state, in RFC 3339 format. If the start time is unknown, UNKNOWN is returned.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :details => String.t(),
          :state => String.t(),
          :templateVersion => String.t(),
          :vmLink => String.t(),
          :vmStartTime => String.t()
        }

  field(:details)
  field(:state)
  field(:templateVersion)
  field(:vmLink)
  field(:vmStartTime)
end

defimpl Poison.Decoder, for: GoogleApi.ReplicaPool.V1beta1.Model.ReplicaStatus do
  def decode(value, options) do
    GoogleApi.ReplicaPool.V1beta1.Model.ReplicaStatus.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.ReplicaPool.V1beta1.Model.ReplicaStatus do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
