# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.ReplicaPool.V1beta1.Model.ServiceAccount do
  @moduledoc """
  A Compute Engine service account, identical to the Compute Engine resource.

  ## Attributes

  *   `email` (*type:* `String.t`, *default:* `nil`) - The service account email address, for example: 123845678986@project.gserviceaccount.com
  *   `scopes` (*type:* `list(String.t)`, *default:* `nil`) - The list of OAuth2 scopes to obtain for the service account, for example: https://www.googleapis.com/auth/devstorage.full_control
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :email => String.t(),
          :scopes => list(String.t())
        }

  field(:email)
  field(:scopes, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.ReplicaPool.V1beta1.Model.ServiceAccount do
  def decode(value, options) do
    GoogleApi.ReplicaPool.V1beta1.Model.ServiceAccount.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.ReplicaPool.V1beta1.Model.ServiceAccount do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
