# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.ReplicaPool.V1beta2.Model.OperationList do
  @moduledoc """


  ## Attributes

  - id (String): Unique identifier for the resource; defined by the server (output only). Defaults to: `null`.
  - items (List[Operation]): The operation resources. Defaults to: `null`.
  - kind (String): Type of resource. Defaults to: `null`.
  - nextPageToken (String): A token used to continue a truncated list request (output only). Defaults to: `null`.
  - selfLink (String): Server defined URL for this resource (output only). Defaults to: `null`.
  """

  defstruct [
    :id,
    :items,
    :kind,
    :nextPageToken,
    :selfLink
  ]
end

defimpl Poison.Decoder, for: GoogleApi.ReplicaPool.V1beta2.Model.OperationList do
  import GoogleApi.ReplicaPool.V1beta2.Deserializer

  def decode(value, options) do
    value
    |> deserialize(:items, :list, GoogleApi.ReplicaPool.V1beta2.Model.Operation, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.ReplicaPool.V1beta2.Model.OperationList do
  def encode(value, options) do
    GoogleApi.ReplicaPool.V1beta2.Deserializer.serialize_non_nil(value, options)
  end
end
