# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.ReplicaPool.V1beta2.Model.OperationWarnings do
  @moduledoc """


  ## Attributes

  - code (String): [Output only] The warning type identifier for this warning. Defaults to: `null`.
    - Enum - one of [DEPRECATED_RESOURCE_USED, DISK_SIZE_LARGER_THAN_IMAGE_SIZE, INJECTED_KERNELS_DEPRECATED, NEXT_HOP_ADDRESS_NOT_ASSIGNED, NEXT_HOP_CANNOT_IP_FORWARD, NEXT_HOP_INSTANCE_NOT_FOUND, NEXT_HOP_INSTANCE_NOT_ON_NETWORK, NEXT_HOP_NOT_RUNNING, NO_RESULTS_ON_PAGE, REQUIRED_TOS_AGREEMENT, RESOURCE_NOT_DELETED, SINGLE_INSTANCE_PROPERTY_TEMPLATE, UNREACHABLE]
  - data (List[OperationData]): [Output only] Metadata for this warning in key:value format. Defaults to: `null`.
  - message (String): [Output only] Optional human-readable details for this warning. Defaults to: `null`.
  """

  defstruct [
    :code,
    :data,
    :message
  ]
end

defimpl Poison.Decoder, for: GoogleApi.ReplicaPool.V1beta2.Model.OperationWarnings do
  import GoogleApi.ReplicaPool.V1beta2.Deserializer

  def decode(value, options) do
    value
    |> deserialize(:data, :list, GoogleApi.ReplicaPool.V1beta2.Model.OperationData, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.ReplicaPool.V1beta2.Model.OperationWarnings do
  def encode(value, options) do
    GoogleApi.ReplicaPool.V1beta2.Deserializer.serialize_non_nil(value, options)
  end
end
