# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.ReplicaPool.V1beta2.Model.ReplicaPoolAutoHealingPolicy do
  @moduledoc """


  ## Attributes

  - actionType (String): The action to perform when an instance becomes unhealthy. Possible values are RECREATE or REBOOT. RECREATE replaces an unhealthy instance with a new instance that is based on the instance template for this managed instance group. REBOOT performs a soft reboot on an instance. If the instance cannot reboot, the instance performs a hard restart. Defaults to: `null`.
    - Enum - one of [REBOOT, RECREATE]
  - healthCheck (String): The URL for the HealthCheck that signals autohealing. Defaults to: `null`.
  """

  defstruct [
    :actionType,
    :healthCheck
  ]
end

defimpl Poison.Decoder, for: GoogleApi.ReplicaPool.V1beta2.Model.ReplicaPoolAutoHealingPolicy do
  def decode(value, _options) do
    value
  end
end

defimpl Poison.Encoder, for: GoogleApi.ReplicaPool.V1beta2.Model.ReplicaPoolAutoHealingPolicy do
  def encode(value, options) do
    GoogleApi.ReplicaPool.V1beta2.Deserializer.serialize_non_nil(value, options)
  end
end
